/*
 * OMAP44xx Power Management register bits
 *
 * Copyright (C) 2009-2010 Texas Instruments, Inc.
 * Copyright (C) 2009-2010 Nokia Corporation
 *
 * Paul Walmsley (paul@pwsan.com)
 * Rajendra Nayak (rnayak@ti.com)
 * Benoit Cousson (b-cousson@ti.com)
 *
 * This file is automatically generated from the OMAP hardware databases.
 * We respectfully ask that any modifications to this file be coordinated
 * with the public linux-omap@vger.kernel.org mailing list and the
 * authors above to ensure that the autogeneration scripts are kept
 * up-to-date with the file contents.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __ARCH_ARM_MACH_OMAP2_PRM_REGBITS_44XX_H
#define __ARCH_ARM_MACH_OMAP2_PRM_REGBITS_44XX_H


/*
 * Used by PRM_LDO_SRAM_CORE_SETUP, PRM_LDO_SRAM_IVA_SETUP,
 * PRM_LDO_SRAM_MPU_SETUP
 */
#define OMAP4430_ABBOFF_ACT_EXPORT_SHIFT				1
#define OMAP4430_ABBOFF_ACT_EXPORT_MASK					(1 << 1)

/*
 * Used by PRM_LDO_SRAM_CORE_SETUP, PRM_LDO_SRAM_IVA_SETUP,
 * PRM_LDO_SRAM_MPU_SETUP
 */
#define OMAP4430_ABBOFF_SLEEP_EXPORT_SHIFT				2
#define OMAP4430_ABBOFF_SLEEP_EXPORT_MASK				(1 << 2)

/* Used by PRM_IRQENABLE_DUCATI, PRM_IRQENABLE_MPU */
#define OMAP4430_ABB_IVA_DONE_EN_SHIFT					31
#define OMAP4430_ABB_IVA_DONE_EN_MASK					(1 << 31)

/* Used by PRM_IRQSTATUS_DUCATI, PRM_IRQSTATUS_MPU */
#define OMAP4430_ABB_IVA_DONE_ST_SHIFT					31
#define OMAP4430_ABB_IVA_DONE_ST_MASK					(1 << 31)

/* Used by PRM_IRQENABLE_MPU_2 */
#define OMAP4430_ABB_MPU_DONE_EN_SHIFT					7
#define OMAP4430_ABB_MPU_DONE_EN_MASK					(1 << 7)

/* Used by PRM_IRQSTATUS_MPU_2 */
#define OMAP4430_ABB_MPU_DONE_ST_SHIFT					7
#define OMAP4430_ABB_MPU_DONE_ST_MASK					(1 << 7)

/* Used by PRM_LDO_ABB_IVA_SETUP, PRM_LDO_ABB_MPU_SETUP */
#define OMAP4430_ACTIVE_FBB_SEL_SHIFT					2
#define OMAP4430_ACTIVE_FBB_SEL_MASK					(1 << 2)

/* Used by PRM_LDO_ABB_IVA_SETUP, PRM_LDO_ABB_MPU_SETUP */
#define OMAP4430_ACTIVE_RBB_SEL_SHIFT					1
#define OMAP4430_ACTIVE_RBB_SEL_MASK					(1 << 1)

/* Used by PM_ABE_PWRSTCTRL */
#define OMAP4430_AESSMEM_ONSTATE_SHIFT					16
#define OMAP4430_AESSMEM_ONSTATE_MASK					(0x3 << 16)

/* Used by PM_ABE_PWRSTCTRL */
#define OMAP4430_AESSMEM_RETSTATE_SHIFT					8
#define OMAP4430_AESSMEM_RETSTATE_MASK					(1 << 8)

/* Used by PM_ABE_PWRSTST */
#define OMAP4430_AESSMEM_STATEST_SHIFT					4
#define OMAP4430_AESSMEM_STATEST_MASK					(0x3 << 4)

/*
 * Used by PRM_LDO_SRAM_CORE_SETUP, PRM_LDO_SRAM_IVA_SETUP,
 * PRM_LDO_SRAM_MPU_SETUP
 */
#define OMAP4430_AIPOFF_SHIFT						8
#define OMAP4430_AIPOFF_MASK						(1 << 8)

/* Used by PRM_VOLTCTRL */
#define OMAP4430_AUTO_CTRL_VDD_CORE_L_SHIFT				0
#define OMAP4430_AUTO_CTRL_VDD_CORE_L_MASK				(0x3 << 0)

/* Used by PRM_VOLTCTRL */
#define OMAP4430_AUTO_CTRL_VDD_IVA_L_SHIFT				4
#define OMAP4430_AUTO_CTRL_VDD_IVA_L_MASK				(0x3 << 4)

/* Used by PRM_VOLTCTRL */
#define OMAP4430_AUTO_CTRL_VDD_MPU_L_SHIFT				2
#define OMAP4430_AUTO_CTRL_VDD_MPU_L_MASK				(0x3 << 2)

/* Used by PRM_VC_ERRST */
#define OMAP4430_BYPS_RA_ERR_SHIFT					25
#define OMAP4430_BYPS_RA_ERR_MASK					(1 << 25)

/* Used by PRM_VC_ERRST */
#define OMAP4430_BYPS_SA_ERR_SHIFT					24
#define OMAP4430_BYPS_SA_ERR_MASK					(1 << 24)

/* Used by PRM_VC_ERRST */
#define OMAP4430_BYPS_TIMEOUT_ERR_SHIFT					26
#define OMAP4430_BYPS_TIMEOUT_ERR_MASK					(1 << 26)

/* Used by PRM_RSTST */
#define OMAP4430_C2C_RST_SHIFT						10
#define OMAP4430_C2C_RST_MASK						(1 << 10)

/* Used by PM_CAM_PWRSTCTRL */
#define OMAP4430_CAM_MEM_ONSTATE_SHIFT					16
#define OMAP4430_CAM_MEM_ONSTATE_MASK					(0x3 << 16)

/* Used by PM_CAM_PWRSTST */
#define OMAP4430_CAM_MEM_STATEST_SHIFT					4
#define OMAP4430_CAM_MEM_STATEST_MASK					(0x3 << 4)

/* Used by PRM_CLKREQCTRL */
#define OMAP4430_CLKREQ_COND_SHIFT					0
#define OMAP4430_CLKREQ_COND_MASK					(0x7 << 0)

/* Used by PRM_VC_VAL_SMPS_RA_CMD */
#define OMAP4430_CMDRA_VDD_CORE_L_SHIFT					0
#define OMAP4430_CMDRA_VDD_CORE_L_MASK					(0xff << 0)

/* Used by PRM_VC_VAL_SMPS_RA_CMD */
#define OMAP4430_CMDRA_VDD_IVA_L_SHIFT					8
#define OMAP4430_CMDRA_VDD_IVA_L_MASK					(0xff << 8)

/* Used by PRM_VC_VAL_SMPS_RA_CMD */
#define OMAP4430_CMDRA_VDD_MPU_L_SHIFT					16
#define OMAP4430_CMDRA_VDD_MPU_L_MASK					(0xff << 16)

/* Used by PRM_VC_CFG_CHANNEL */
#define OMAP4430_CMD_VDD_CORE_L_SHIFT					4
#define OMAP4430_CMD_VDD_CORE_L_MASK					(1 << 4)

/* Used by PRM_VC_CFG_CHANNEL */
#define OMAP4430_CMD_VDD_IVA_L_SHIFT					12
#define OMAP4430_CMD_VDD_IVA_L_MASK					(1 << 12)

/* Used by PRM_VC_CFG_CHANNEL */
#define OMAP4430_CMD_VDD_MPU_L_SHIFT					17
#define OMAP4430_CMD_VDD_MPU_L_MASK					(1 << 17)

/* Used by PM_CORE_PWRSTCTRL */
#define OMAP4430_CORE_OCMRAM_ONSTATE_SHIFT				18
#define OMAP4430_CORE_OCMRAM_ONSTATE_MASK				(0x3 << 18)

/* Used by PM_CORE_PWRSTCTRL */
#define OMAP4430_CORE_OCMRAM_RETSTATE_SHIFT				9
#define OMAP4430_CORE_OCMRAM_RETSTATE_MASK				(1 << 9)

/* Used by PM_CORE_PWRSTST */
#define OMAP4430_CORE_OCMRAM_STATEST_SHIFT				6
#define OMAP4430_CORE_OCMRAM_STATEST_MASK				(0x3 << 6)

/* Used by PM_CORE_PWRSTCTRL */
#define OMAP4430_CORE_OTHER_BANK_ONSTATE_SHIFT				16
#define OMAP4430_CORE_OTHER_BANK_ONSTATE_MASK				(0x3 << 16)

/* Used by PM_CORE_PWRSTCTRL */
#define OMAP4430_CORE_OTHER_BANK_RETSTATE_SHIFT				8
#define OMAP4430_CORE_OTHER_BANK_RETSTATE_MASK				(1 << 8)

/* Used by PM_CORE_PWRSTST */
#define OMAP4430_CORE_OTHER_BANK_STATEST_SHIFT				4
#define OMAP4430_CORE_OTHER_BANK_STATEST_MASK				(0x3 << 4)

/* Used by REVISION_PRM */
#define OMAP4430_CUSTOM_SHIFT						6
#define OMAP4430_CUSTOM_MASK						(0x3 << 6)

/* Used by PRM_VC_VAL_BYPASS */
#define OMAP4430_DATA_SHIFT						16
#define OMAP4430_DATA_MASK						(0xff << 16)

/* Used by PRM_DEVICE_OFF_CTRL */
#define OMAP4430_DEVICE_OFF_ENABLE_SHIFT				0
#define OMAP4430_DEVICE_OFF_ENABLE_MASK					(1 << 0)

/* Used by PRM_VC_CFG_I2C_MODE */
#define OMAP4430_DFILTEREN_SHIFT					6
#define OMAP4430_DFILTEREN_MASK						(1 << 6)

/*
 * Used by PRM_LDO_SRAM_CORE_SETUP, PRM_LDO_SRAM_IVA_SETUP,
 * PRM_LDO_SRAM_MPU_SETUP, PRM_SRAM_WKUP_SETUP
 */
#define OMAP4430_DISABLE_RTA_EXPORT_SHIFT				0
#define OMAP4430_DISABLE_RTA_EXPORT_MASK				(1 << 0)

/* Used by PRM_IRQENABLE_DUCATI, PRM_IRQENABLE_MPU, PRM_IRQENABLE_TESLA */
#define OMAP4430_DPLL_ABE_RECAL_EN_SHIFT				4
#define OMAP4430_DPLL_ABE_RECAL_EN_MASK					(1 << 4)

/* Used by PRM_IRQSTATUS_DUCATI, PRM_IRQSTATUS_MPU, PRM_IRQSTATUS_TESLA */
#define OMAP4430_DPLL_ABE_RECAL_ST_SHIFT				4
#define OMAP4430_DPLL_ABE_RECAL_ST_MASK					(1 << 4)

/* Used by PRM_IRQENABLE_DUCATI, PRM_IRQENABLE_MPU */
#define OMAP4430_DPLL_CORE_RECAL_EN_SHIFT				0
#define OMAP4430_DPLL_CORE_RECAL_EN_MASK				(1 << 0)

/* Used by PRM_IRQSTATUS_DUCATI, PRM_IRQSTATUS_MPU */
#define OMAP4430_DPLL_CORE_RECAL_ST_SHIFT				0
#define OMAP4430_DPLL_CORE_RECAL_ST_MASK				(1 << 0)

/* Used by PRM_IRQENABLE_MPU */
#define OMAP4430_DPLL_DDRPHY_RECAL_EN_SHIFT				6
#define OMAP4430_DPLL_DDRPHY_RECAL_EN_MASK				(1 << 6)

/* Used by PRM_IRQSTATUS_MPU */
#define OMAP4430_DPLL_DDRPHY_RECAL_ST_SHIFT				6
#define OMAP4430_DPLL_DDRPHY_RECAL_ST_MASK				(1 << 6)

/* Used by PRM_IRQENABLE_DUCATI, PRM_IRQENABLE_MPU, PRM_IRQENABLE_TESLA */
#define OMAP4430_DPLL_IVA_RECAL_EN_SHIFT				2
#define OMAP4430_DPLL_IVA_RECAL_EN_MASK					(1 << 2)

/* Used by PRM_IRQSTATUS_DUCATI, PRM_IRQSTATUS_MPU, PRM_IRQSTATUS_TESLA */
#define OMAP4430_DPLL_IVA_RECAL_ST_SHIFT				2
#define OMAP4430_DPLL_IVA_RECAL_ST_MASK					(1 << 2)

/* Used by PRM_IRQENABLE_MPU */
#define OMAP4430_DPLL_MPU_RECAL_EN_SHIFT				1
#define OMAP4430_DPLL_MPU_RECAL_EN_MASK					(1 << 1)

/* Used by PRM_IRQSTATUS_MPU */
#define OMAP4430_DPLL_MPU_RECAL_ST_SHIFT				1
#define OMAP4430_DPLL_MPU_RECAL_ST_MASK					(1 << 1)

/* Used by PRM_IRQENABLE_DUCATI, PRM_IRQENABLE_MPU */
#define OMAP4430_DPLL_PER_RECAL_EN_SHIFT				3
#define OMAP4430_DPLL_PER_RECAL_EN_MASK					(1 << 3)

/* Used by PRM_IRQSTATUS_DUCATI, PRM_IRQSTATUS_MPU */
#define OMAP4430_DPLL_PER_RECAL_ST_SHIFT				3
#define OMAP4430_DPLL_PER_RECAL_ST_MASK					(1 << 3)

/* Used by PRM_IRQENABLE_DUCATI, PRM_IRQENABLE_MPU */
#define OMAP4430_DPLL_UNIPRO_RECAL_EN_SHIFT				7
#define OMAP4430_DPLL_UNIPRO_RECAL_EN_MASK				(1 << 7)

/* Used by PRM_IRQSTATUS_DUCATI, PRM_IRQSTATUS_MPU */
#define OMAP4430_DPLL_UNIPRO_RECAL_ST_SHIFT				7
#define OMAP4430_DPLL_UNIPRO_RECAL_ST_MASK				(1 << 7)

/* Used by PM_DSS_PWRSTCTRL */
#define OMAP4430_DSS_MEM_ONSTATE_SHIFT					16
#define OMAP4430_DSS_MEM_ONSTATE_MASK					(0x3 << 16)

/* Used by PM_DSS_PWRSTCTRL */
#define OMAP4430_DSS_MEM_RETSTATE_SHIFT					8
#define OMAP4430_DSS_MEM_RETSTATE_MASK					(1 << 8)

/* Used by PM_DSS_PWRSTST */
#define OMAP4430_DSS_MEM_STATEST_SHIFT					4
#define OMAP4430_DSS_MEM_STATEST_MASK					(0x3 << 4)

/* Used by PM_CORE_PWRSTCTRL */
#define OMAP4430_DUCATI_L2RAM_ONSTATE_SHIFT				20
#define OMAP4430_DUCATI_L2RAM_ONSTATE_MASK				(0x3 << 20)

/* Used by PM_CORE_PWRSTCTRL */
#define OMAP4430_DUCATI_L2RAM_RETSTATE_SHIFT				10
#define OMAP4430_DUCATI_L2RAM_RETSTATE_MASK				(1 << 10)

/* Used by PM_CORE_PWRSTST */
#define OMAP4430_DUCATI_L2RAM_STATEST_SHIFT				8
#define OMAP4430_DUCATI_L2RAM_STATEST_MASK				(0x3 << 8)

/* Used by PM_CORE_PWRSTCTRL */
#define OMAP4430_DUCATI_UNICACHE_ONSTATE_SHIFT				22
#define OMAP4430_DUCATI_UNICACHE_ONSTATE_MASK				(0x3 << 22)

/* Used by PM_CORE_PWRSTCTRL */
#define OMAP4430_DUCATI_UNICACHE_RETSTATE_SHIFT				11
#define OMAP4430_DUCATI_UNICACHE_RETSTATE_MASK				(1 << 11)

/* Used by PM_CORE_PWRSTST */
#define OMAP4430_DUCATI_UNICACHE_STATEST_SHIFT				10
#define OMAP4430_DUCATI_UNICACHE_STATEST_MASK				(0x3 << 10)

/* Used by PRM_DEVICE_OFF_CTRL */
#define OMAP4460_EMIF1_OFFWKUP_DISABLE_SHIFT				8
#define OMAP4460_EMIF1_OFFWKUP_DISABLE_MASK				(1 << 8)

/* Used by PRM_DEVICE_OFF_CTRL */
#define OMAP4460_EMIF2_OFFWKUP_DISABLE_SHIFT				9
#define OMAP4460_EMIF2_OFFWKUP_DISABLE_MASK				(1 << 9)

/* Used by RM_MPU_RSTST */
#define OMAP4430_EMULATION_RST_SHIFT					0
#define OMAP4430_EMULATION_RST_MASK					(1 << 0)

/* Used by RM_DUCATI_RSTST */
#define OMAP4430_EMULATION_RST1ST_SHIFT					3
#define OMAP4430_EMULATION_RST1ST_MASK					(1 << 3)

/* Used by RM_DUCATI_RSTST */
#define OMAP4430_EMULATION_RST2ST_SHIFT					4
#define OMAP4430_EMULATION_RST2ST_MASK					(1 << 4)

/* Used by RM_IVAHD_RSTST */
#define OMAP4430_EMULATION_SEQ1_RST1ST_SHIFT				3
#define OMAP4430_EMULATION_SEQ1_RST1ST_MASK				(1 << 3)

/* Used by RM_IVAHD_RSTST */
#define OMAP4430_EMULATION_SEQ2_RST2ST_SHIFT				4
#define OMAP4430_EMULATION_SEQ2_RST2ST_MASK				(1 << 4)

/* Used by PM_EMU_PWRSTCTRL */
#define OMAP4430_EMU_BANK_ONSTATE_SHIFT					16
#define OMAP4430_EMU_BANK_ONSTATE_MASK					(0x3 << 16)

/* Used by PM_EMU_PWRSTST */
#define OMAP4430_EMU_BANK_STATEST_SHIFT					4
#define OMAP4430_EMU_BANK_STATEST_MASK					(0x3 << 4)

/*
 * Used by PRM_LDO_SRAM_CORE_SETUP, PRM_LDO_SRAM_IVA_SETUP,
 * PRM_LDO_SRAM_MPU_SETUP
 */
#define OMAP4430_ENFUNC1_EXPORT_SHIFT					3
#define OMAP4430_ENFUNC1_EXPORT_MASK					(1 << 3)

/*
 * Used by PRM_LDO_SRAM_CORE_SETUP, PRM_LDO_SRAM_IVA_SETUP,
 * PRM_LDO_SRAM_MPU_SETUP
 */
#define OMAP4430_ENFUNC3_EXPORT_SHIFT					5
#define OMAP4430_ENFUNC3_EXPORT_MASK					(1 << 5)

/*
 * Used by PRM_LDO_SRAM_CORE_SETUP, PRM_LDO_SRAM_IVA_SETUP,
 * PRM_LDO_SRAM_MPU_SETUP
 */
#define OMAP4430_ENFUNC4_SHIFT						6
#define OMAP4430_ENFUNC4_MASK						(1 << 6)

/*
 * Used by PRM_LDO_SRAM_CORE_SETUP, PRM_LDO_SRAM_IVA_SETUP,
 * PRM_LDO_SRAM_MPU_SETUP
 */
#define OMAP4430_ENFUNC5_SHIFT						7
#define OMAP4430_ENFUNC5_MASK						(1 << 7)

/* Used by PRM_VP_CORE_CONFIG, PRM_VP_IVA_CONFIG, PRM_VP_MPU_CONFIG */
#define OMAP4430_ERRORGAIN_SHIFT					16
#define OMAP4430_ERRORGAIN_MASK						(0xff << 16)

/* Used by PRM_VP_CORE_CONFIG, PRM_VP_IVA_CONFIG, PRM_VP_MPU_CONFIG */
#define OMAP4430_ERROROFFSET_SHIFT					24
#define OMAP4430_ERROROFFSET_MASK					(0xff << 24)

/* Used by PRM_RSTST */
#define OMAP4430_EXTERNAL_WARM_RST_SHIFT				5
#define OMAP4430_EXTERNAL_WARM_RST_MASK					(1 << 5)

/* Used by PRM_VP_CORE_CONFIG, PRM_VP_IVA_CONFIG, PRM_VP_MPU_CONFIG */
#define OMAP4430_FORCEUPDATE_SHIFT					1
#define OMAP4430_FORCEUPDATE_MASK					(1 << 1)
